# valuenode.cpp File Reference

Implementation of the "Placeholder" valuenode conversion. More...

`#include "valuenode.h"`
`#include "general.h"`
`#include "canvas.h"`
`#include "paramdesc.h"`
`#include "releases.h"`
`#include "valuenode_const.h"`
`#include "valuenode_linear.h"`
`#include "valuenode_composite.h"`
`#include "valuenode_reference.h"`
`#include "valuenode_greyed.h"`
`#include "valuenode_scale.h"`
`#include "valuenode_blinecalctangent.h"`
`#include "valuenode_blinecalcvertex.h"`
`#include "valuenode_blinecalcwidth.h"`
`#include "valuenode_blinereversetangent.h"`
`#include "valuenode_segcalctangent.h"`
`#include "valuenode_segcalcvertex.h"`
`#include "valuenode_repeat_gradient.h"`
`#include "valuenode_stripes.h"`
`#include "valuenode_range.h"`
`#include "valuenode_add.h"`
`#include "valuenode_subtract.h"`
`#include "valuenode_timedswap.h"`
`#include "valuenode_twotone.h"`
`#include "valuenode_bline.h"`
`#include "valuenode_dynamiclist.h"`
`#include "valuenode_radialcomposite.h"`
`#include "valuenode_gradientrotate.h"`
`#include "valuenode_sine.h"`
`#include "valuenode_cos.h"`
`#include "valuenode_atan2.h"`
`#include "valuenode_exp.h"`
`#include "valuenode_switch.h"`
`#include "valuenode_timeloop.h"`
`#include "valuenode_reciprocal.h"`
`#include "valuenode_duplicate.h"`
`#include "valuenode_integer.h"`
`#include "valuenode_step.h"`
`#include "valuenode_vectorangle.h"`
`#include "valuenode_vectorlength.h"`
`#include "valuenode_vectorx.h"`
`#include "valuenode_vectory.h"`
`#include "valuenode_gradientcolor.h"`
`#include "valuenode_dotproduct.h"`
`#include "valuenode_timestring.h"`
`#include "valuenode_realstring.h"`
`#include "valuenode_join.h"`
`#include "valuenode_anglestring.h"`
`#include "valuenode_intstring.h"`
`#include "valuenode_log.h"`
`#include "valuenode_pow.h"`
`#include "valuenode_compare.h"`
`#include "valuenode_not.h"`
`#include "valuenode_and.h"`
`#include "valuenode_or.h"`
`#include "layer.h"`

## Defines

#define | SYNFIG_NO_ANGLE
#define | ADD_VALUENODE(class, name, local, version)
#define | ADD_VALUENODE2(class, name, local, version)

## Functions

static int | value_node_count (0)
ValueNode::LooseHandle | synfig::find_value_node (const GUID &guid)

## Variables

static LinkableValueNode::Book * | book_

## Detailed Description

Implementation of the "Placeholder" valuenode conversion.

$Id$

## Define Documentation

#define SYNFIG_NO_ANGLE

#define ADD_VALUENODE | ( | class,
|  | name,
|  | local,
|  | version |  | ) |

Value:

    (*book_)[name].factory=reinterpret_cast<LinkableValueNode::Factory>(&class::create);        \
        (*book_)[name].check_type=&class::check_type;                                               \
        (*book_)[name].local_name=local;                                                            \
        (*book_)[name].release_version=version

Referenced by synfig::ValueNode::subsys_init().

#define ADD_VALUENODE2 | ( | class,
|  | name,
|  | local,
|  | version |  | ) |

Value:

    (*book_)[name].factory=reinterpret_cast<LinkableValueNode::Factory>(&class::create_from);   \
        (*book_)[name].check_type=&class::check_type;                                               \
        (*book_)[name].local_name=local;                                                            \
        (*book_)[name].release_version=version

Referenced by synfig::ValueNode::subsys_init().

## Function Documentation

static int value_node_count | ( | 0 |  | ) | `[static]`

Referenced by synfig::ValueNode::ValueNode(), and synfig::ValueNode::~ValueNode().

## Variable Documentation

LinkableValueNode::Book* book_ `[static]`

Referenced by synfig::LinkableValueNode::book(), synfig::ValueNode::subsys_init(), and synfig::ValueNode::subsys_stop().